<script>
  import { scaleLinear } from 'd3-scale';
	import { scaleOrdinal } from 'd3-scale';
	import { schemePastel2 } from 'd3-scale-chromatic';
  // Dimensions
  const width = 800;
  const height = 100;
  const margin = { top: 20, right: 5, bottom: 5, left: 5 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;

  // array
  const values = [
    { x: 2, y: 1, category: "cat1" },
    { x: 4, y: 2, category: "cat3" },
    { x: 6, y: 1, category: "cat2" },
    { x: 7, y: 3, category: "cat3" },
    { x: 9, y: 1, category: "cat2" }
  ];

  // Scale
  const scaleX = scaleLinear().domain([0,10]).range([0,innerWidth]);
  const scaleY = scaleLinear().domain([0,3]).range([innerHeight,0]);
	const scaleColour = scaleOrdinal(schemePastel2);
</script>

<svg viewBox="0 0 {width} {height}">
  <g transform="translate({margin.left},{margin.top})">
    {#each values as v}
      <line x1={scaleX(v.x)} y1={scaleY(v.y)} x2={scaleX(v.x)} y2={innerHeight}/>
      <circle cx={scaleX(v.x)} cy={scaleY(v.y)} r=6
							style={"fill:" + scaleColour(v.category)}/>
      <text class=valueLabel x={scaleX(v.x)} y={scaleY(v.y)-10}>{v.y}</text>
    {/each}
  </g>
  <line x1={margin.left} x2={width-margin.right} y1={height-margin.bottom} y2={height-margin.bottom}/>
</svg>

<style>
  line {
    stroke: black;
  }
  text {
    text-anchor: middle;
    font-size: small;
  }
</style>